package cn.com.tenlion.configtable.service.configtable;

import cn.com.tenlion.configtable.pojo.dtos.configtableoperation.ConfigTableOperationDTO;
import ink.wgink.exceptions.SearchException;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.configtable.pojo.dtos.configtable.ConfigTableDTO;
import cn.com.tenlion.configtable.pojo.vos.configtable.ConfigTableVO;
import cn.com.tenlion.configtable.pojo.bos.configtable.ConfigTableBO;
import cn.com.tenlion.configtable.pojo.pos.configtable.ConfigTablePO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IConfigTableService
 * @Description: 
 * @Author: CodeFactory
 * @Date: 2021-06-24 10:59:30
 * @Version: 3.0
 **/
public interface IConfigTableService {

    /**
     * 新增
     *
     * @param configTableVO
     * @return
     */
    void save(ConfigTableVO configTableVO);

    /**
     * 新增
     *
     * @param token
     * @param configTableVO
     * @return
     */
    void save(String token, ConfigTableVO configTableVO);

    /**
     * 新增
     *
     * @param configTableVO
     * @return configTableId
     */
    String saveReturnId(ConfigTableVO configTableVO);

    /**
     * 新增
     *
     * @param token
     * @param configTableVO
     * @return configTableId
     */
    String saveReturnId(String token, ConfigTableVO configTableVO);

    /**
     * 删除
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改
     *
     * @param configTableId
     * @param configTableVO
     * @return
     */
    void update(String configTableId, ConfigTableVO configTableVO);

    /**
     * 修改
     *
     * @param token
     * @param configTableId
     * @param configTableVO
     * @return
     */
    void update(String token, String configTableId, ConfigTableVO configTableVO);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigTableDTO get(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configTableId
     * @return
     */
    ConfigTableDTO get(String configTableId);

    /**
     * 通过编号获得表单
     *
     * @param configTableNumber
     * @return
     */
    ConfigTableDTO getByNumber(String configTableNumber);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigTableBO getBO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configTableId
     * @return
     */
    ConfigTableBO getBO(String configTableId);

    /**
     * 详情
     *
     * @param params 参数Map
     * @return
     */
    ConfigTablePO getPO(Map<String, Object> params);

    /**
     * 详情
     *
     * @param configTableId
     * @return
     */
    ConfigTablePO getPO(String configTableId);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigTableDTO> list(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigTableBO> listBO(Map<String, Object> params);

    /**
     * 列表
     *
     * @param params
     * @return
     */
    List<ConfigTablePO> listPO(Map<String, Object> params);

    /**
     * 分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<ConfigTableDTO>> listPage(ListPage page);

    /**
     * 统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    /**
     * 激活表单
     * @param configTableId
     */
    void saveAction(String configTableId);

    ConfigTableDTO getTableCode(String configTableCode);

    /**
     * 删除信息并删除数据库表
     * @param asList
     */
    void removeTable(List<String> asList);

}